//K4NFP CW LIBRARY.

void morsePulse(int pin, int dela) {
  tone(pin, 500);
  delay(dela);
  noTone(pin);
}

void morse(String aftrtext, int pin) {
  int unit = 50; //(ms)
  int wordspace = unit * 7;
  int dit   = unit;
  int dah   = unit * 3;
  aftrtext.toUpperCase();
  String text;
  String morseLetters[] = {
    ".-", //A
    "-...", // B
    "-.-.", // C
    "-..", // D
    ".", // E
    "..-.", // F
    "--.", // G
    "....", // H
    "..", // I
    ".---", // J
    "-.-", // K
    ".-..", // L
    "--", // M
    "-.", // N
    "---", // O
    ".--.", // P
    "--.-", // Q
    ".-.", // R
    "...", // S
    "-", // T
    "..-", // U
    "...-", // V
    ".--", // W
    "-..-", // X
    "-.--", // Y
    "--.."  // Z
  };

  String morseNumbers[] = {
    "-----", // 0
    ".----", // 1
    "..---", // 2
    "...--", // 3
    "....-", // 4
    ".....", // 5
    "-....", // 6
    "--...", // 7
    "---..", // 8
    "----.", // 9
  };
  for (int j = 0; j < aftrtext.length(); j++) {
    int d = aftrtext.charAt(j);
    if (d > 64 and d < 91) {
      text += morseLetters[d - 65] + " ";
    } //That means its a letter
    else if (d > 47 and d < 58) {
      text += morseNumbers[d - 48] + " ";
    } //That means its a number
    else if (d == 32) {
      text += "/";
    } // new word (spacebar)
  }
    for (int i = 0; i < text.length(); i++) {
      char c = text.charAt(i);
      if (c == '-') {
        morsePulse(pin, dah);
      } else if (c == '.') {
        morsePulse(pin, dit);
      } else if (c == '/') {
        delay(wordspace);
      }
      if (c == '/') {}
      else if (c == ' ') {
        delay(dah);
      } else {
        delay(unit);
      }
    }
}